
#include <stream.h>
#include "x.h"

Nodeset::Nodeset(NodeType Type, int num, int port):type(Type),
		number(num), portcount(port)  { 
    portlink = new Linkset* [port] ;
}

Nodeset::~Nodeset() { delete[] portlink ;}

void Nodeset::assign(float sp, Linkset** link) {
    if (type = CPU) floatspeed = sp ;
    else grainsize = sp ;
    for (int i=0; i<portcount; i++) portlink[i] = link[i] ;
    portlink[0]->display() ;
}

/*
void Nodeset::assign(Linkset** link) {
    Linkset** portlink = new Linkset* [port] ;
    for (int i=0; i<port; i++) portlink[i] = link[i] ;
}
*/

void Nodeset::display() {
    cout << number << " " << floatspeed << endl ;
    portlink[0]->display() ;
}


main()
{
    Nodeset Nodeset0(CPU, 32, 1);
    Nodeset Nodeset1(Cache, 32, 2);
    Nodeset Nodeset2(Memory, 32, 2);
    Nodeset Nodeset3(Switch, 1, 1);
    Linkset LinksetA(Updown, Full, 321) ;
    Linkset LinksetB(Updown, Full, 320) ;
    Linkset LinksetC(Updown, Full, 32) ;

    Linkset ** p = new Linkset* [1] ;
    p[0] = &LinksetA ;
    Nodeset0.assign(1.0e-8, p);
    delete[] p ;

/*
    p = new Linkset* [2];
    p[0] = &LinksetB ;
    p[1] = &LinksetA ;
    Nodeset1.assign(1, 2, p) ;
    delete p ;

    p = new Linkset* [2];
    p[0] = &LinksetC ;
    p[1] = &LinksetB ;
    Nodeset2.assign(128, 2, p) ;
    delete p ;

    p = new Linkset* [1] ;
    p[0] = &LinksetC ;
    Nodeset3.assign(1, p) ;
    delete p ;
*/
 
    LinksetA.assign(&Nodeset0, &Nodeset1) ;
    LinksetB.assign(&Nodeset1, &Nodeset2) ;
    LinksetC.assign(&Nodeset2, &Nodeset3) ;

    Nodeset0.display();
    LinksetA.display() ;
}
